from app.libraries.database import Database
from app.libraries.setup import Setup
from mastodon import Mastodon
import os
import sys

if __name__ == '__main__':

    db = Database()

    setup = Setup()

    mastodon = Mastodon(
        access_token = setup.mastodon_app_token,
        api_base_url= setup.mastodon_hostname
        )

    topten_servers, topten_versions, topten_users, mast_servers, mast_users = db.get_versions()

    toot_text = f'\nTotal alive Mastodon servers: {str(mast_servers)}\n\n'

    toot_text += f'Top ten most used Mastodon versions: \n\n'

    toot_text += f'version, servers, users\n\n'

    i = 0

    while i < 10:

        servers = '{0:,}'.format((topten_servers[i]))

        users = '{0:,}'.format((topten_users[i]))

        toot_text += f'v{topten_versions[i]}, {servers} ({str(round(((topten_servers[i] * 100) / mast_servers), 2))}%), {users} ({str(round(((topten_users[i] * 100) / mast_users), 2))}%)\n'

        i += 1

    toot_text += '\n#Mastodon'

    print(toot_text)

    mastodon.status_post(toot_text, in_reply_to_id=None, )
